"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
let KoaRegistry = class KoaRegistry {
    constructor() {
        this.instances = new Map();
    }

    addInstance(id, instance) {
        if (!this.instances.has(id)) {
            this.instances.set(id, instance);
        }
    }

    getInstances() {
        return this.instances;
    }

    getInstanceById(id) {
        if (this.instances.has(id)) {
            return this.instances.get(id);
        }

        return null;
    }

    addMiddleware(instanceId, middleware) {
        const instance = this.getInstanceById(instanceId);

        instance.use(middleware);
    }

    async addMiddlewareBuilder(instanceId, builder) {
        let middlewares = await builder.build();

        for (let middleware of middlewares) {
            this.addMiddleware(instanceId, middleware);
        }
    }
};
exports.default = KoaRegistry;
module.exports = exports["default"];