"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
let RegisterInstance = class RegisterInstance {
    async process(container) {
        const registryDefinition = container.getDefinition("solfege_koa_registry");

        const serviceIds = container.findTaggedServiceIds("solfege.koa.instance");
        for (let serviceId of serviceIds) {
            const instanceReference = container.getReference(serviceId);
            const instanceDefinition = container.getDefinition(serviceId);
            const tags = instanceDefinition.getTags();

            for (let tag of tags) {
                if (tag.name !== "solfege.koa.instance") {
                    continue;
                }

                const instanceId = tag.id;
                registryDefinition.addMethodCall("addInstance", [instanceId, instanceReference]);
            }
        }
    }
};
exports.default = RegisterInstance;
module.exports = exports["default"];