"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
let UseMiddleware = class UseMiddleware {
    async process(container) {
        const registryDefinition = container.getDefinition("solfege_koa_registry");

        let serviceIds = container.findTaggedServiceIds("solfege.koa.middleware");
        for (let serviceId of serviceIds) {
            const middlewareReference = container.getReference(serviceId);
            const middlewareDefinition = container.getDefinition(serviceId);
            const tags = middlewareDefinition.getTags();

            for (let tag of tags) {
                if (tag.name !== "solfege.koa.middleware") {
                    continue;
                }

                const instanceId = tag.target;
                registryDefinition.addMethodCall("addMiddleware", [instanceId, middlewareReference]);
            }
        }

        serviceIds = container.findTaggedServiceIds("solfege.koa.middleware_builder");
        for (let serviceId of serviceIds) {
            const middlewareReference = container.getReference(serviceId);
            const middlewareDefinition = container.getDefinition(serviceId);
            const tags = middlewareDefinition.getTags();

            for (let tag of tags) {
                if (tag.name !== "solfege.koa.middleware_builder") {
                    continue;
                }

                const instanceId = tag.target;
                registryDefinition.addMethodCall("addMiddlewareBuilder", [instanceId, middlewareReference]);
            }
        }
    }
};
exports.default = UseMiddleware;
module.exports = exports["default"];